//
//  NSString+Category.h
//  Lighting
//
//  Created by 曹云霄 on 2016/12/23.
//  Copyright © 2016年 上海勾芒科技有限公司. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSString (Category)

/**
 *  计算文字高度
 *
 *  @param fontSize 字体大小
 *  @param width    宽度
 *
 *  @return 高度
 */
- (CGFloat)heightWithFontSize:(CGFloat)fontSize width:(CGFloat)width;

/**
 *  计算文字宽度度
 *
 *  @param fontSize 字体大小
 *  @param height   高度
 *
 *  @return 宽度
 */
- (CGFloat)widthWithFontSize:(CGFloat)fontSize height:(CGFloat)height;


/**
 格式化字符串
 
 @param string 去掉前后空格
 */
- (NSString *)formatString;
@end
